#increase memory limit of R to 3000 MB
memory.limit(size = 4000)

#read in packages
library(rgdal)
library(sp)
library(SDMTools)
library(igraph)

#read in historic wetlands shapefile
HistWets <- readOGR("G:/NewBackup/GIS/RWBWetlandConnectivity/base/HistWetsPntsGeographic.shp", "HistWetsPntsGeographic", verbose = TRUE, p4s = NULL)

#read in and modify csv files of node connections forming dispersal paths at 4 dispersal distances
#####
#####
#####
#0.5 km
retain <- c("FromNode", "ToNode")
HalfKMPaths1 <- read.csv("HalfKMPaths1.csv")
HalfKMPaths1$FromNode <- HalfKMPaths1$unlist.FromNode1.
HalfKMPaths1$ToNode <- HalfKMPaths1$unlist.ToNode1.
HalfKMPaths1 <- HalfKMPaths1[retain]

HalfKMPaths2 <- read.csv("HalfKMPaths2.csv")
HalfKMPaths2$FromNode <- HalfKMPaths2$unlist.FromNode2.
HalfKMPaths2$ToNode <- HalfKMPaths2$unlist.ToNode2.
HalfKMPaths2 <- HalfKMPaths2[retain]

HalfKMPaths3 <- read.csv("HalfKMPaths3.csv")
HalfKMPaths3$FromNode <- HalfKMPaths3$unlist.FromNode3.
HalfKMPaths3$ToNode <- HalfKMPaths3$unlist.ToNode3.
HalfKMPaths3 <- HalfKMPaths3[retain]

HalfKMPaths4 <- read.csv("HalfKMPaths4.csv")
HalfKMPaths4$FromNode <- HalfKMPaths4$unlist.FromNode4.
HalfKMPaths4$ToNode <- HalfKMPaths4$unlist.ToNode4.
HalfKMPaths4 <- HalfKMPaths4[retain]

HalfKMPaths5 <- read.csv("HalfKMPaths5.csv")
HalfKMPaths5$FromNode <- HalfKMPaths5$unlist.FromNode5.
HalfKMPaths5$ToNode <- HalfKMPaths5$unlist.ToNode5.
HalfKMPaths5 <- HalfKMPaths5[retain]

HalfKMPaths6 <- read.csv("HalfKMPaths6.csv")
HalfKMPaths6$FromNode <- HalfKMPaths6$unlist.FromNode6.
HalfKMPaths6$ToNode <- HalfKMPaths6$unlist.ToNode6.
HalfKMPaths6 <- HalfKMPaths6[retain]

HalfKMPaths7 <- read.csv("HalfKMPaths7.csv")
HalfKMPaths7$FromNode <- HalfKMPaths7$unlist.FromNode7.
HalfKMPaths7$ToNode <- HalfKMPaths7$unlist.ToNode7.
HalfKMPaths7 <- HalfKMPaths7[retain]

HalfKMPaths8 <- read.csv("HalfKMPaths8.csv")
HalfKMPaths8$FromNode <- HalfKMPaths8$unlist.FromNode8.
HalfKMPaths8$ToNode <- HalfKMPaths8$unlist.ToNode8.
HalfKMPaths8 <- HalfKMPaths8[retain]

HalfKMPaths9 <- read.csv("HalfKMPaths9.csv")
HalfKMPaths9$FromNode <- HalfKMPaths9$unlist.FromNode9.
HalfKMPaths9$ToNode <- HalfKMPaths9$unlist.ToNode9.
HalfKMPaths9 <- HalfKMPaths9[retain]

HalfKMPaths10 <- read.csv("HalfKMPaths10.csv")
HalfKMPaths10$FromNode <- HalfKMPaths10$unlist.FromNode10.
HalfKMPaths10$ToNode <- HalfKMPaths10$unlist.ToNode10.
HalfKMPaths10 <- HalfKMPaths10[retain]

HalfKMPaths11 <- read.csv("HalfKMPaths11.csv")
HalfKMPaths11$FromNode <- HalfKMPaths11$unlist.FromNode11.
HalfKMPaths11$ToNode <- HalfKMPaths11$unlist.ToNode11.
HalfKMPaths11 <- HalfKMPaths11[retain]

HalfKMPaths12 <- read.csv("HalfKMPaths12.csv")
HalfKMPaths12$FromNode <- HalfKMPaths12$unlist.FromNode12.
HalfKMPaths12$ToNode <- HalfKMPaths12$unlist.ToNode12.
HalfKMPaths12 <- HalfKMPaths12[retain]

#combine 0.5 km connections into 1 data frame
HalfKMPathsCombined <- rbind(HalfKMPaths1, HalfKMPaths2, HalfKMPaths3, HalfKMPaths4, HalfKMPaths5, HalfKMPaths6, HalfKMPaths7, HalfKMPaths8, HalfKMPaths9, HalfKMPaths10, HalfKMPaths11, HalfKMPaths12)
HalfKMPathsCombined <- as.matrix(HalfKMPathsCombined[-7368,])
HalfKMPathsCombined

#create network with nodes and associated edges
HalfKMNetwork <- graph(n = 11711, edges = HalfKMPathsCombined, directed = FALSE)

#calculate node and edge betweeness for graph (number of shortest paths going through node or edge)
HalfKMNodeBetweenness <- betweenness(HalfKMNetwork, v = V(HalfKMNetwork), directed = FALSE, weights = NULL, normalized = FALSE)
HalfKMNodeBetweenness
MeanNodeBetweennessHalfKM <- mean(HalfKMNodeBetweenness)
MeanNodeBetweennessHalfKM

HalfKMEdgeBetweenness <- edge.betweenness(HalfKMNetwork, e = E(HalfKMNetwork), directed = FALSE, weights = NULL)
HalfKMEdgeBetweenness
MeanEdgeBetweennessHalfKM <- mean(HalfKMEdgeBetweenness)
MeanEdgeBetweennessHalfKM

#calculate degree (number of adjacent edges for each node)
DegreeHalfKMNetwork <- degree(HalfKMNetwork, v = V(HalfKMNetwork), loops = TRUE)
DegreeHalfKMNetwork
MeanDegreeHalfKMNetwork <- mean(DegreeHalfKMNetwork)
MeanDegreeHalfKMNetwork

#find number of clusters (groups of connected graph components)
HalfKMNetworkNumberClusters <- no.clusters(HalfKMNetwork)
HalfKMNetworkNumberClusters

#find mean number of vertices per cluster
HalfKMNetworkClusters <- clusters(HalfKMNetwork)
summary(HalfKMNetworkClusters$csize)
HalfKMNetworkMeanClusterSize <- mean(HalfKMNetworkClusters$csize)
HalfKMNetworkMeanClusterSize

#find subcomponent (all other vertices reachable from specified vertice)
HalfKMNetworkSC <- list(NA)
NumberReachedHalfKM <- list(NA)
for(i in 1:nrow(HistWets@data)){
	HalfKMNetworkSC[[i]] <- subcomponent(HalfKMNetwork, v = i)
	NumberReachedHalfKM[[i]] <- length(HalfKMNetworkSC[[i]]) - 1
}
NumberReachedHalfKM <- unlist(NumberReachedHalfKM)
NumberReachedHalfKMMean <- mean(NumberReachedHalfKM)
NumberReachedHalfKMMean

#edge betweeness community (creates hierarchical graph by removing edges most traveled when reaching other vertices via algorithm)
HalfKMNetworkEBC <- edge.betweenness.community(HalfKMNetwork, edge.betweenness = TRUE, merges = TRUE, bridges = TRUE)

#calculate eigenvector centrality scores of network positions (high scores = vertices connected to other highly connected which are connected to other highly connected etc...)
HalfKMNetworkEVCENT <- evcent(HalfKMNetwork, directed = FALSE, scale = FALSE)
HalfKMNetworkEVCENT

#calculate graph density (ratio of number of edges to number of possible edges)
HalfKMNetworkGraphDensity <- graph.density(HalfKMNetwork, loops = TRUE)
HalfKMNetworkGraphDensity

#identify neighbors of each vertice
HalfKMNetworkNeighbors <- list(NA)
for (i in 1:nrow(HistWets@data)){
	HalfKMNetworkNeighbors[[i]] <- neighbors(HalfKMNetwork, v = i)
}
HalfKMNetworkNeighbors

#calculate neighborhood size (number of interconnected vertices in each neighborhood)
HalfKMNetworkNeighborSize <- neighborhood.size(HalfKMNetwork, order = 1, nodes = V(HalfKMNetwork))
HalfKMNetworkNeighborSize

#calculate graph cohesion (vertex connectivity of graph)
HalfKMNetworkGraphCohesion <- graph.cohesion(HalfKMNetwork)
HalfKMNetworkGraphCohesion

#calculate average shortest path length between connected vertices
HalfKMNetworkAPL <- average.path.length(HalfKMNetwork, directed = FALSE, unconnected = TRUE)
HalfKMNetworkAPL

#generate histogram of shortest path lengths
HalfKMNetworkAPLHist <- path.length.hist(HalfKMNetwork, directed = FALSE)
HalfKMNetworkAPLHist

#experiment with deleting vertices/edges
NodeRemove <- list(NA)
MeanNodeDegreeRemoval <- list(NA)
MeanNodeBetweennessRemoval <- list(NA)
MeanEdgeBetweennessRemoval <- list(NA)
GraphDensityRemoval <- list(NA)
MeanShortPathLengthRemoval <- list(NA)
for(i in 1:nrow(HistWets@data)){
	NodeRemove[[i]] <- HalfKMNetwork
	NodeRemove[[i]][i] <- FALSE
	MeanNodeDegreeRemoval[[i]] <- mean(degree(NodeRemove[[i]], v = V(NodeRemove[[i]]), loops = TRUE))
	MeanNodeBetweennessRemoval[[i]] <- mean(betweenness(NodeRemove[[i]], v = V(NodeRemove[[i]]), directed = FALSE, weights = NULL, normalized = FALSE))
	MeanEdgeBetweennessRemoval[[i]] <- mean(edge.betweenness(NodeRemove[[i]], e = E(NodeRemove[[i]]), directed = FALSE, weights = NULL))
	GraphDensityRemoval[[i]] <- graph.density(NodeRemove[[i]], loops = TRUE)
	MeanShortPathLengthRemoval[[i]] <- average.path.length(NodeRemove[[i]], directed = FALSE, unconnected = TRUE)
}

#unlist mean degrees after removing each node
MeanNodeDegreeRemoval <- unlist(MeanNodeDegreeRemoval)
MeanNodeDegreeRemoval <- data.frame(MeanNodeDegreeRemoval)
MeanNodeDegreeRemoval$Degree <- MeanNodeDegreeRemoval[,1]
MeanNodeDegreeRemoval$NodeID <- HistWets@data$NodeID
MeanNodeDegreeRemoval$FP_ID <- HistWets@data$FP_ID
MeanNodeDegreeRemoval <- MeanNodeDegreeRemoval[,-1]
head(MeanNodeDegreeRemoval)

#unlist mean node betweenness after removing and replacing each node sequentially
MeanNodeBetweennessRemoval <- unlist(MeanNodeBetweennessRemoval)
MeanNodeBetweennessRemoval <- data.frame(MeanNodeBetweennessRemoval)
MeanNodeBetweennessRemoval$NodeBetweenness <- MeanNodeBetweennessRemoval[,1]
MeanNodeBetweennessRemoval$NodeID <- HistWets@data$NodeID
MeanNodeBetweennessRemoval$FP_ID <- HistWets@data$FP_ID
MeanNodeBetweennessRemoval <- MeanNodeBetweennessRemoval[,-1]
head(MeanNodeBetweennessRemoval)

#unlist mean edge betweenness after removing and replacing each node sequentially
MeanEdgeBetweennessRemoval <- unlist(MeanEdgeBetweennessRemoval)
MeanEdgeBetweennessRemoval <- data.frame(MeanEdgeBetweennessRemoval)
MeanEdgeBetweennessRemoval$EdgeBetweenness <- MeanEdgeBetweennessRemoval[,1]
MeanEdgeBetweennessRemoval$NodeID <- HistWets@data$NodeID
MeanEdgeBetweennessRemoval$FP_ID <- HistWets@data$FP_ID
MeanEdgeBetweennessRemoval <- MeanEdgeBetweennessRemoval[,-1]
head(MeanEdgeBetweennessRemoval)

#unlist graph density after removing and replacing each node sequentially
GraphDensityRemoval <- unlist(GraphDensityRemoval)
GraphDensityRemoval <- data.frame(GraphDensityRemoval)
GraphDensityRemoval$GraphDensity <- GraphDensityRemoval[,1]
GraphDensityRemoval$NodeID <- HistWets@data$NodeID
GraphDensityRemoval$FP_ID <- HistWets@data$FP_ID
GraphDensityRemoval <- GraphDensityRemoval[,-1]
head(GraphDensityRemoval)

#unlist mean shortest path length after removing and replacing each node sequentially
MeanShortPathLengthRemoval <- unlist(MeanShortPathLengthRemoval)
MeanShortPathLengthRemoval <- data.frame(MeanShortPathLengthRemoval)
MeanShortPathLengthRemoval$MeanPathLength <- MeanShortPathLengthRemoval[,1]
MeanShortPathLengthRemoval$NodeID <- HistWets@data$NodeID
MeanShortPathLengthRemoval$FP_ID <- HistWets@data$FP_ID
MeanShortPathLengthRemoval <- MeanShortPathLengthRemoval[,-1]
head(MeanShortPathLengthRemoval)

#add new outputs to attribute table
HistWets@data$Degree <- DegreeHalfKMNetwork
HistWets@data$NodeBetween <- HalfKMNodeBetweenness
HistWets@data$RemDeg <- MeanNodeDegreeRemoval$Degree
HistWets@data$RemNodeBetween <- MeanNodeBetweennessRemoval$NodeBetweenness
HistWets@data$RemEdgeBetween <- MeanEdgeBetweennessRemoval$EdgeBetweenness
HistWets@data$RemGraphDenity <- GraphDensityRemoval$GraphDensity
HistWets@data$RemShortPath <- MeanShortPathLengthRemoval$MeanPathLength

#write updated spatial polygons data frame as an ESRI shapefile
writeOGR(HistWets, "HistWetsHalfKMNetwork", "HistWetsHalfKMNetwork", driver = 'ESRI Shapefile', verbose = TRUE)

#####
#####
#####
#1.0 km
retain <- c("FromNode", "ToNode")
OneKMPaths1 <- read.csv("OneKMPaths1.csv")
OneKMPaths1$FromNode <- OneKMPaths1$unlist.FromNode1.
OneKMPaths1$ToNode <- OneKMPaths1$unlist.ToNode1.
OneKMPaths1 <- OneKMPaths1[retain]

OneKMPaths2 <- read.csv("OneKMPaths2.csv")
OneKMPaths2$FromNode <- OneKMPaths2$unlist.FromNode2.
OneKMPaths2$ToNode <- OneKMPaths2$unlist.ToNode2.
OneKMPaths2 <- OneKMPaths2[retain]

OneKMPaths3 <- read.csv("OneKMPaths3.csv")
OneKMPaths3$FromNode <- OneKMPaths3$unlist.FromNode3.
OneKMPaths3$ToNode <- OneKMPaths3$unlist.ToNode3.
OneKMPaths3 <- OneKMPaths3[retain]

OneKMPaths4 <- read.csv("OneKMPaths4.csv")
OneKMPaths4$FromNode <- OneKMPaths4$unlist.FromNode4.
OneKMPaths4$ToNode <- OneKMPaths4$unlist.ToNode4.
OneKMPaths4 <- OneKMPaths4[retain]

OneKMPaths5 <- read.csv("OneKMPaths5.csv")
OneKMPaths5$FromNode <- OneKMPaths5$unlist.FromNode5.
OneKMPaths5$ToNode <- OneKMPaths5$unlist.ToNode5.
OneKMPaths5 <- OneKMPaths5[retain]

OneKMPaths6 <- read.csv("OneKMPaths6.csv")
OneKMPaths6$FromNode <- OneKMPaths6$unlist.FromNode6.
OneKMPaths6$ToNode <- OneKMPaths6$unlist.ToNode6.
OneKMPaths6 <- OneKMPaths6[retain]

OneKMPaths7 <- read.csv("OneKMPaths7.csv")
OneKMPaths7$FromNode <- OneKMPaths7$unlist.FromNode7.
OneKMPaths7$ToNode <- OneKMPaths7$unlist.ToNode7.
OneKMPaths7 <- OneKMPaths7[retain]

OneKMPaths8 <- read.csv("OneKMPaths8.csv")
OneKMPaths8$FromNode <- OneKMPaths8$unlist.FromNode8.
OneKMPaths8$ToNode <- OneKMPaths8$unlist.ToNode8.
OneKMPaths8 <- OneKMPaths8[retain]

OneKMPaths9 <- read.csv("OneKMPaths9.csv")
OneKMPaths9$FromNode <- OneKMPaths9$unlist.FromNode9.
OneKMPaths9$ToNode <- OneKMPaths9$unlist.ToNode9.
OneKMPaths9 <- OneKMPaths9[retain]

OneKMPaths10 <- read.csv("OneKMPaths10.csv")
OneKMPaths10$FromNode <- OneKMPaths10$unlist.FromNode10.
OneKMPaths10$ToNode <- OneKMPaths10$unlist.ToNode10.
OneKMPaths10 <- OneKMPaths10[retain]

OneKMPaths11 <- read.csv("OneKMPaths11.csv")
OneKMPaths11$FromNode <- OneKMPaths11$unlist.FromNode11.
OneKMPaths11$ToNode <- OneKMPaths11$unlist.ToNode11.
OneKMPaths11 <- OneKMPaths11[retain]

OneKMPaths12 <- read.csv("OneKMPaths12.csv")
OneKMPaths12$FromNode <- OneKMPaths12$unlist.FromNode12.
OneKMPaths12$ToNode <- OneKMPaths12$unlist.ToNode12.
OneKMPaths12 <- OneKMPaths12[retain]

#combine 1.0 km connections into 1 data frame
OneKMPathsCombined <- rbind(OneKMPaths1, OneKMPaths2, OneKMPaths3, OneKMPaths4, OneKMPaths5, OneKMPaths6, OneKMPaths7, OneKMPaths8, OneKMPaths9, OneKMPaths10, OneKMPaths11, OneKMPaths12)
OneKMPathsCombined <- as.matrix(OneKMPathsCombined[-28350,])

#create network with nodes and associated edges
OneKMNetwork <- graph(n = 11711, edges = OneKMPathsCombined, directed = FALSE)

#calculate node and edge betweeness for graph (number of shortest paths going through node or edge)
OneKMNodeBetweenness <- betweenness(OneKMNetwork, v = V(OneKMNetwork), directed = FALSE, weights = NULL, normalized = FALSE)
OneKMNodeBetweenness
MeanNodeBetweennessOneKM <- mean(OneKMNodeBetweenness)
MeanNodeBetweennessOneKM

OneKMEdgeBetweenness <- edge.betweenness(OneKMNetwork, e = E(OneKMNetwork), directed = FALSE, weights = NULL)
OneKMEdgeBetweenness
MeanEdgeBetweennessOneKM <- mean(OneKMEdgeBetweenness)
MeanEdgeBetweennessOneKM

#calculate degree (number of adjacent edges for each node)
DegreeOneKMNetwork <- degree(OneKMNetwork, v = V(OneKMNetwork), loops = TRUE)
DegreeOneKMNetwork
MeanDegreeOneKMNetwork <- mean(DegreeOneKMNetwork)
MeanDegreeOneKMNetwork

#find number of clusters (groups of connected graph components)
OneKMNetworkNumberClusters <- no.clusters(OneKMNetwork)
OneKMNetworkNumberClusters

#find mean number of vertices per cluster
OneKMNetworkClusters <- clusters(OneKMNetwork)
summary(OneKMNetworkClusters$csize)
OneKMNetworkMeanClusterSize <- mean(OneKMNetworkClusters$csize)
OneKMNetworkMeanClusterSize

#find subcomponent (all other vertices reachable from specified vertice)
OneKMNetworkSC <- list(NA)
NumberReachedOneKM <- list(NA)
for(i in 1:nrow(HistWets@data)){
	OneKMNetworkSC[[i]] <- subcomponent(OneKMNetwork, v = i)
	NumberReachedOneKM[[i]] <- length(OneKMNetworkSC[[i]]) - 1
}
NumberReachedOneKM <- unlist(NumberReachedOneKM)
NumberReachedOneKMMean <- mean(NumberReachedOneKM)
NumberReachedOneKMMean

#edge betweeness community (creates hierarchical graph by removing edges most traveled when reaching other vertices via algorithm)
OneKMNetworkEBC <- edge.betweenness.community(OneKMNetwork, edge.betweenness = TRUE, merges = TRUE, bridges = TRUE)

#calculate eigenvector centrality scores of network positions (high scores = vertices connected to other highly connected which are connected to other highly connected etc...)
OneKMNetworkEVCENT <- evcent(OneKMNetwork, directed = FALSE, scale = FALSE)
OneKMNetworkEVCENT

#calculate graph density (ratio of number of edges to number of possible edges)
OneKMNetworkGraphDensity <- graph.density(OneKMNetwork, loops = TRUE)
OneKMNetworkGraphDensity

#identify neighbors of each vertice
OneKMNetworkNeighbors <- list(NA)
for (i in 1:nrow(HistWets@data)){
	OneKMNetworkNeighbors[[i]] <- neighbors(OneKMNetwork, v = i)
}
OneKMNetworkNeighbors

#calculate neighborhood size (number of interconnected vertices in each neighborhood)
OneKMNetworkNeighborSize <- neighborhood.size(OneKMNetwork, order = 1, nodes = V(OneKMNetwork))
OneKMNetworkNeighborSize

#calculate graph cohesion (vertex connectivity of graph)
OneKMNetworkGraphCohesion <- graph.cohesion(OneKMNetwork)
OneKMNetworkGraphCohesion

#calculate average shortest path length between connected vertices
OneKMNetworkAPL <- average.path.length(OneKMNetwork, directed = FALSE, unconnected = TRUE)
OneKMNetworkAPL

#generate histogram of shortest path lengths
OneKMNetworkAPLHist <- path.length.hist(OneKMNetwork, directed = FALSE)
OneKMNetworkAPLHist

#experiment with deleting vertices/edges
NodeRemove <- list(NA)
MeanNodeDegreeRemoval <- list(NA)
MeanNodeBetweennessRemoval <- list(NA)
MeanEdgeBetweennessRemoval <- list(NA)
GraphDensityRemoval <- list(NA)
MeanShortPathLengthRemoval <- list(NA)
for(i in 1:nrow(HistWets@data)){
	NodeRemove[[i]] <- OneKMNetwork
	NodeRemove[[i]][i] <- FALSE
	MeanNodeDegreeRemoval[[i]] <- mean(degree(NodeRemove[[i]], v = V(NodeRemove[[i]]), loops = TRUE))
	MeanNodeBetweennessRemoval[[i]] <- mean(betweenness(NodeRemove[[i]], v = V(NodeRemove[[i]]), directed = FALSE, weights = NULL, normalized = FALSE))
	MeanEdgeBetweennessRemoval[[i]] <- mean(edge.betweenness(NodeRemove[[i]], e = E(NodeRemove[[i]]), directed = FALSE, weights = NULL))
	GraphDensityRemoval[[i]] <- graph.density(NodeRemove[[i]], loops = TRUE)
	MeanShortPathLengthRemoval[[i]] <- average.path.length(NodeRemove[[i]], directed = FALSE, unconnected = TRUE)
}

#unlist mean degrees after removing each node
MeanNodeDegreeRemoval <- unlist(MeanNodeDegreeRemoval)
MeanNodeDegreeRemoval <- data.frame(MeanNodeDegreeRemoval)
MeanNodeDegreeRemoval$Degree <- MeanNodeDegreeRemoval[,1]
MeanNodeDegreeRemoval$NodeID <- HistWets@data$NodeID
MeanNodeDegreeRemoval$FP_ID <- HistWets@data$FP_ID
MeanNodeDegreeRemoval <- MeanNodeDegreeRemoval[,-1]
head(MeanNodeDegreeRemoval)

#unlist mean node betweenness after removing and replacing each node sequentially
MeanNodeBetweennessRemoval <- unlist(MeanNodeBetweennessRemoval)
MeanNodeBetweennessRemoval <- data.frame(MeanNodeBetweennessRemoval)
MeanNodeBetweennessRemoval$NodeBetweenness <- MeanNodeBetweennessRemoval[,1]
MeanNodeBetweennessRemoval$NodeID <- HistWets@data$NodeID
MeanNodeBetweennessRemoval$FP_ID <- HistWets@data$FP_ID
MeanNodeBetweennessRemoval <- MeanNodeBetweennessRemoval[,-1]
head(MeanNodeBetweennessRemoval)

#unlist mean edge betweenness after removing and replacing each node sequentially
MeanEdgeBetweennessRemoval <- unlist(MeanEdgeBetweennessRemoval)
MeanEdgeBetweennessRemoval <- data.frame(MeanEdgeBetweennessRemoval)
MeanEdgeBetweennessRemoval$EdgeBetweenness <- MeanEdgeBetweennessRemoval[,1]
MeanEdgeBetweennessRemoval$NodeID <- HistWets@data$NodeID
MeanEdgeBetweennessRemoval$FP_ID <- HistWets@data$FP_ID
MeanEdgeBetweennessRemoval <- MeanEdgeBetweennessRemoval[,-1]
head(MeanEdgeBetweennessRemoval)

#unlist graph density after removing and replacing each node sequentially
GraphDensityRemoval <- unlist(GraphDensityRemoval)
GraphDensityRemoval <- data.frame(GraphDensityRemoval)
GraphDensityRemoval$GraphDensity <- GraphDensityRemoval[,1]
GraphDensityRemoval$NodeID <- HistWets@data$NodeID
GraphDensityRemoval$FP_ID <- HistWets@data$FP_ID
GraphDensityRemoval <- GraphDensityRemoval[,-1]
head(GraphDensityRemoval)

#unlist mean shortest path length after removing and replacing each node sequentially
MeanShortPathLengthRemoval <- unlist(MeanShortPathLengthRemoval)
MeanShortPathLengthRemoval <- data.frame(MeanShortPathLengthRemoval)
MeanShortPathLengthRemoval$MeanPathLength <- MeanShortPathLengthRemoval[,1]
MeanShortPathLengthRemoval$NodeID <- HistWets@data$NodeID
MeanShortPathLengthRemoval$FP_ID <- HistWets@data$FP_ID
MeanShortPathLengthRemoval <- MeanShortPathLengthRemoval[,-1]
head(MeanShortPathLengthRemoval)

#add new outputs to attribute table
HistWets@data$Degree <- DegreeOneKMNetwork
HistWets@data$NodeBetween <- OneKMNodeBetweenness
HistWets@data$RemDeg <- MeanNodeDegreeRemoval$Degree
HistWets@data$RemNodeBetween <- MeanNodeBetweennessRemoval$NodeBetweenness
HistWets@data$RemEdgeBetween <- MeanEdgeBetweennessRemoval$EdgeBetweenness
HistWets@data$RemGraphDenity <- GraphDensityRemoval$GraphDensity
HistWets@data$RemShortPath <- MeanShortPathLengthRemoval$MeanPathLength

#write updated spatial polygons data frame as an ESRI shapefile
writeOGR(HistWets, "HistWetsOneKMNetwork", "HistWetsOneKMNetwork", driver = 'ESRI Shapefile', verbose = TRUE)

#####
#####
#####
#1.5 km
retain <- c("FromNode", "ToNode")
OneAndHalfKMPaths1 <- read.csv("OneAndHalfKMPaths1.csv")
OneAndHalfKMPaths1$FromNode <- OneAndHalfKMPaths1$unlist.FromNode1.
OneAndHalfKMPaths1$ToNode <- OneAndHalfKMPaths1$unlist.ToNode1.
OneAndHalfKMPaths1 <- OneAndHalfKMPaths1[retain]

OneAndHalfKMPaths2 <- read.csv("OneAndHalfKMPaths2.csv")
OneAndHalfKMPaths2$FromNode <- OneAndHalfKMPaths2$unlist.FromNode2.
OneAndHalfKMPaths2$ToNode <- OneAndHalfKMPaths2$unlist.ToNode2.
OneAndHalfKMPaths2 <- OneAndHalfKMPaths2[retain]

OneAndHalfKMPaths3 <- read.csv("OneAndHalfKMPaths3.csv")
OneAndHalfKMPaths3$FromNode <- OneAndHalfKMPaths3$unlist.FromNode3.
OneAndHalfKMPaths3$ToNode <- OneAndHalfKMPaths3$unlist.ToNode3.
OneAndHalfKMPaths3 <- OneAndHalfKMPaths3[retain]

OneAndHalfKMPaths4 <- read.csv("OneAndHalfKMPaths4.csv")
OneAndHalfKMPaths4$FromNode <- OneAndHalfKMPaths4$unlist.FromNode4.
OneAndHalfKMPaths4$ToNode <- OneAndHalfKMPaths4$unlist.ToNode4.
OneAndHalfKMPaths4 <- OneAndHalfKMPaths4[retain]

OneAndHalfKMPaths5 <- read.csv("OneAndHalfKMPaths5.csv")
OneAndHalfKMPaths5$FromNode <- OneAndHalfKMPaths5$unlist.FromNode5.
OneAndHalfKMPaths5$ToNode <- OneAndHalfKMPaths5$unlist.ToNode5.
OneAndHalfKMPaths5 <- OneAndHalfKMPaths5[retain]

OneAndHalfKMPaths6 <- read.csv("OneAndHalfKMPaths6.csv")
OneAndHalfKMPaths6$FromNode <- OneAndHalfKMPaths6$unlist.FromNode6.
OneAndHalfKMPaths6$ToNode <- OneAndHalfKMPaths6$unlist.ToNode6.
OneAndHalfKMPaths6 <- OneAndHalfKMPaths6[retain]

OneAndHalfKMPaths7 <- read.csv("OneAndHalfKMPaths7.csv")
OneAndHalfKMPaths7$FromNode <- OneAndHalfKMPaths7$unlist.FromNode7.
OneAndHalfKMPaths7$ToNode <- OneAndHalfKMPaths7$unlist.ToNode7.
OneAndHalfKMPaths7 <- OneAndHalfKMPaths7[retain]

OneAndHalfKMPaths8 <- read.csv("OneAndHalfKMPaths8.csv")
OneAndHalfKMPaths8$FromNode <- OneAndHalfKMPaths8$unlist.FromNode8.
OneAndHalfKMPaths8$ToNode <- OneAndHalfKMPaths8$unlist.ToNode8.
OneAndHalfKMPaths8 <- OneAndHalfKMPaths8[retain]

OneAndHalfKMPaths9 <- read.csv("OneAndHalfKMPaths9.csv")
OneAndHalfKMPaths9$FromNode <- OneAndHalfKMPaths9$unlist.FromNode9.
OneAndHalfKMPaths9$ToNode <- OneAndHalfKMPaths9$unlist.ToNode9.
OneAndHalfKMPaths9 <- OneAndHalfKMPaths9[retain]

OneAndHalfKMPaths10 <- read.csv("OneAndHalfKMPaths10.csv")
OneAndHalfKMPaths10$FromNode <- OneAndHalfKMPaths10$unlist.FromNode10.
OneAndHalfKMPaths10$ToNode <- OneAndHalfKMPaths10$unlist.ToNode10.
OneAndHalfKMPaths10 <- OneAndHalfKMPaths10[retain]

OneAndHalfKMPaths11 <- read.csv("OneAndHalfKMPaths11.csv")
OneAndHalfKMPaths11$FromNode <- OneAndHalfKMPaths11$unlist.FromNode11.
OneAndHalfKMPaths11$ToNode <- OneAndHalfKMPaths11$unlist.ToNode11.
OneAndHalfKMPaths11 <- OneAndHalfKMPaths11[retain]

OneAndHalfKMPaths12 <- read.csv("OneAndHalfKMPaths12.csv")
OneAndHalfKMPaths12$FromNode <- OneAndHalfKMPaths12$unlist.FromNode12.
OneAndHalfKMPaths12$ToNode <- OneAndHalfKMPaths12$unlist.ToNode12.
OneAndHalfKMPaths12 <- OneAndHalfKMPaths12[retain]

#combine 1.5 km connections into 1 data frame
OneAndHalfKMPathsCombined <- rbind(OneAndHalfKMPaths1, OneAndHalfKMPaths2, OneAndHalfKMPaths3, OneAndHalfKMPaths4, OneAndHalfKMPaths5, OneAndHalfKMPaths6, OneAndHalfKMPaths7, OneAndHalfKMPaths8, OneAndHalfKMPaths9, OneAndHalfKMPaths10, OneAndHalfKMPaths11, OneAndHalfKMPaths12)
OneAndHalfKMPathsCombined <- as.matrix(OneAndHalfKMPathsCombined[-58511,])

#create network with nodes and associated edges
OneAndHalfKMNetwork <- graph(n = 11711, edges = OneAndHalfKMPathsCombined, directed = FALSE)

#calculate node and edge betweeness for graph (number of shortest paths going through node or edge)
OneAndHalfKMNodeBetweenness <- betweenness(OneAndHalfKMNetwork, v = V(OneAndHalfKMNetwork), directed = FALSE, weights = NULL, normalized = FALSE)
OneAndHalfKMNodeBetweenness
MeanNodeBetweennessOneAndHalfKM <- mean(OneAndHalfKMNodeBetweenness)
MeanNodeBetweennessOneAndHalfKM

OneAndHalfKMEdgeBetweenness <- edge.betweenness(OneAndHalfKMNetwork, e = E(OneAndHalfKMNetwork), directed = FALSE, weights = NULL)
OneAndHalfKMEdgeBetweenness
MeanEdgeBetweennessOneAndHalfKM <- mean(OneAndHalfKMEdgeBetweenness)
MeanEdgeBetweennessOneAndHalfKM

#calculate degree (number of adjacent edges for each node)
DegreeOneAndHalfKMNetwork <- degree(OneAndHalfKMNetwork, v = V(OneAndHalfKMNetwork), loops = TRUE)
DegreeOneAndHalfKMNetwork
MeanDegreeOneAndHalfKMNetwork <- mean(DegreeOneAndHalfKMNetwork)
MeanDegreeOneAndHalfKMNetwork

#find number of clusters (groups of connected graph components)
OneAndHalfKMNetworkNumberClusters <- no.clusters(OneAndHalfKMNetwork)
OneAndHalfKMNetworkNumberClusters

#find mean number of vertices per cluster
OneAndHalfKMNetworkClusters <- clusters(OneAndHalfKMNetwork)
summary(OneAndHalfKMNetworkClusters$csize)
OneAndHalfKMNetworkMeanClusterSize <- mean(OneAndHalfKMNetworkClusters$csize)
OneAndHalfKMNetworkMeanClusterSize

#find subcomponent (all other vertices reachable from specified vertice)
OneAndHalfKMNetworkSC <- list(NA)
NumberReachedOneAndHalfKM <- list(NA)
for(i in 1:nrow(HistWets@data)){
	OneAndHalfKMNetworkSC[[i]] <- subcomponent(OneAndHalfKMNetwork, v = i)
	NumberReachedOneAndHalfKM[[i]] <- length(OneAndHalfKMNetworkSC[[i]]) - 1
}
NumberReachedOneAndHalfKM <- unlist(NumberReachedOneAndHalfKM)
NumberReachedOneAndHalfKMMean <- mean(NumberReachedOneAndHalfKM)
NumberReachedOneAndHalfKMMean

#edge betweeness community (creates hierarchical graph by removing edges most traveled when reaching other vertices via algorithm)
OneAndHalfKMNetworkEBC <- edge.betweenness.community(OneAndHalfKMNetwork, edge.betweenness = TRUE, merges = TRUE, bridges = TRUE)

#calculate eigenvector centrality scores of network positions (high scores = vertices connected to other highly connected which are connected to other highly connected etc...)
OneAndHalfKMNetworkEVCENT <- evcent(OneAndHalfKMNetwork, directed = FALSE, scale = FALSE)
OneAndHalfKMNetworkEVCENT

#calculate graph density (ratio of number of edges to number of possible edges)
OneAndHalfKMNetworkGraphDensity <- graph.density(OneAndHalfKMNetwork, loops = TRUE)
OneAndHalfKMNetworkGraphDensity

#identify neighbors of each vertice
OneAndHalfKMNetworkNeighbors <- list(NA)
for (i in 1:nrow(HistWets@data)){
	OneAndHalfKMNetworkNeighbors[[i]] <- neighbors(OneAndHalfKMNetwork, v = i)
}
OneAndHalfKMNetworkNeighbors

#calculate neighborhood size (number of interconnected vertices in each neighborhood)
OneAndHalfKMNetworkNeighborSize <- neighborhood.size(OneAndHalfKMNetwork, order = 1, nodes = V(OneAndHalfKMNetwork))
OneAndHalfKMNetworkNeighborSize

#calculate graph cohesion (vertex connectivity of graph)
OneAndHalfKMNetworkGraphCohesion <- graph.cohesion(OneAndHalfKMNetwork)
OneAndHalfKMNetworkGraphCohesion

#calculate average shortest path length between connected vertices
OneAndHalfKMNetworkAPL <- average.path.length(OneAndHalfKMNetwork, directed = FALSE, unconnected = TRUE)
OneAndHalfKMNetworkAPL

#generate histogram of shortest path lengths
OneAndHalfKMNetworkAPLHist <- path.length.hist(OneAndHalfKMNetwork, directed = FALSE)
OneAndHalfKMNetworkAPLHist

#experiment with deleting vertices/edges
NodeRemove <- list(NA)
MeanNodeDegreeRemoval <- list(NA)
MeanNodeBetweennessRemoval <- list(NA)
MeanEdgeBetweennessRemoval <- list(NA)
GraphDensityRemoval <- list(NA)
MeanShortPathLengthRemoval <- list(NA)
for(i in 1:nrow(HistWets@data)){
	NodeRemove[[i]] <- OneAndHalfKMNetwork
	NodeRemove[[i]][i] <- FALSE
	MeanNodeDegreeRemoval[[i]] <- mean(degree(NodeRemove[[i]], v = V(NodeRemove[[i]]), loops = TRUE))
	MeanNodeBetweennessRemoval[[i]] <- mean(betweenness(NodeRemove[[i]], v = V(NodeRemove[[i]]), directed = FALSE, weights = NULL, normalized = FALSE))
	MeanEdgeBetweennessRemoval[[i]] <- mean(edge.betweenness(NodeRemove[[i]], e = E(NodeRemove[[i]]), directed = FALSE, weights = NULL))
	GraphDensityRemoval[[i]] <- graph.density(NodeRemove[[i]], loops = TRUE)
	MeanShortPathLengthRemoval[[i]] <- average.path.length(NodeRemove[[i]], directed = FALSE, unconnected = TRUE)
}

#unlist mean degrees after removing each node
MeanNodeDegreeRemoval <- unlist(MeanNodeDegreeRemoval)
MeanNodeDegreeRemoval <- data.frame(MeanNodeDegreeRemoval)
MeanNodeDegreeRemoval$Degree <- MeanNodeDegreeRemoval[,1]
MeanNodeDegreeRemoval$NodeID <- HistWets@data$NodeID
MeanNodeDegreeRemoval$FP_ID <- HistWets@data$FP_ID
MeanNodeDegreeRemoval <- MeanNodeDegreeRemoval[,-1]
head(MeanNodeDegreeRemoval)

#unlist mean node betweenness after removing and replacing each node sequentially
MeanNodeBetweennessRemoval <- unlist(MeanNodeBetweennessRemoval)
MeanNodeBetweennessRemoval <- data.frame(MeanNodeBetweennessRemoval)
MeanNodeBetweennessRemoval$NodeBetweenness <- MeanNodeBetweennessRemoval[,1]
MeanNodeBetweennessRemoval$NodeID <- HistWets@data$NodeID
MeanNodeBetweennessRemoval$FP_ID <- HistWets@data$FP_ID
MeanNodeBetweennessRemoval <- MeanNodeBetweennessRemoval[,-1]
head(MeanNodeBetweennessRemoval)

#unlist mean edge betweenness after removing and replacing each node sequentially
MeanEdgeBetweennessRemoval <- unlist(MeanEdgeBetweennessRemoval)
MeanEdgeBetweennessRemoval <- data.frame(MeanEdgeBetweennessRemoval)
MeanEdgeBetweennessRemoval$EdgeBetweenness <- MeanEdgeBetweennessRemoval[,1]
MeanEdgeBetweennessRemoval$NodeID <- HistWets@data$NodeID
MeanEdgeBetweennessRemoval$FP_ID <- HistWets@data$FP_ID
MeanEdgeBetweennessRemoval <- MeanEdgeBetweennessRemoval[,-1]
head(MeanEdgeBetweennessRemoval)

#unlist graph density after removing and replacing each node sequentially
GraphDensityRemoval <- unlist(GraphDensityRemoval)
GraphDensityRemoval <- data.frame(GraphDensityRemoval)
GraphDensityRemoval$GraphDensity <- GraphDensityRemoval[,1]
GraphDensityRemoval$NodeID <- HistWets@data$NodeID
GraphDensityRemoval$FP_ID <- HistWets@data$FP_ID
GraphDensityRemoval <- GraphDensityRemoval[,-1]
head(GraphDensityRemoval)

#unlist mean shortest path length after removing and replacing each node sequentially
MeanShortPathLengthRemoval <- unlist(MeanShortPathLengthRemoval)
MeanShortPathLengthRemoval <- data.frame(MeanShortPathLengthRemoval)
MeanShortPathLengthRemoval$MeanPathLength <- MeanShortPathLengthRemoval[,1]
MeanShortPathLengthRemoval$NodeID <- HistWets@data$NodeID
MeanShortPathLengthRemoval$FP_ID <- HistWets@data$FP_ID
MeanShortPathLengthRemoval <- MeanShortPathLengthRemoval[,-1]
head(MeanShortPathLengthRemoval)

#add new outputs to attribute table
HistWets@data$Degree <- DegreeOneAndHalfKMNetwork
HistWets@data$NodeBetween <- OneAndHalfKMNodeBetweenness
HistWets@data$RemDeg <- MeanNodeDegreeRemoval$Degree
HistWets@data$RemNodeBetween <- MeanNodeBetweennessRemoval$NodeBetweenness
HistWets@data$RemEdgeBetween <- MeanEdgeBetweennessRemoval$EdgeBetweenness
HistWets@data$RemGraphDenity <- GraphDensityRemoval$GraphDensity
HistWets@data$RemShortPath <- MeanShortPathLengthRemoval$MeanPathLength

#write updated spatial polygons data frame as an ESRI shapefile
writeOGR(HistWets, "HistWetsOneAndHalfKMNetwork", "HistWetsOneAndHalfKMNetwork", driver = 'ESRI Shapefile', verbose = TRUE)

#####
#####
#####
#2.0 km
retain <- c("FromNode", "ToNode")
TwoKMPaths1 <- read.csv("TwoKMPaths1.csv")
TwoKMPaths1$FromNode <- TwoKMPaths1$unlist.FromNode1.
TwoKMPaths1$ToNode <- TwoKMPaths1$unlist.ToNode1.
TwoKMPaths1 <- TwoKMPaths1[retain]

TwoKMPaths2 <- read.csv("TwoKMPaths2.csv")
TwoKMPaths2$FromNode <- TwoKMPaths2$unlist.FromNode2.
TwoKMPaths2$ToNode <- TwoKMPaths2$unlist.ToNode2.
TwoKMPaths2 <- TwoKMPaths2[retain]

TwoKMPaths3 <- read.csv("TwoKMPaths3.csv")
TwoKMPaths3$FromNode <- TwoKMPaths3$unlist.FromNode3.
TwoKMPaths3$ToNode <- TwoKMPaths3$unlist.ToNode3.
TwoKMPaths3 <- TwoKMPaths3[retain]

TwoKMPaths4 <- read.csv("TwoKMPaths4.csv")
TwoKMPaths4$FromNode <- TwoKMPaths4$unlist.FromNode4.
TwoKMPaths4$ToNode <- TwoKMPaths4$unlist.ToNode4.
TwoKMPaths4 <- TwoKMPaths4[retain]

TwoKMPaths5 <- read.csv("TwoKMPaths5.csv")
TwoKMPaths5$FromNode <- TwoKMPaths5$unlist.FromNode5.
TwoKMPaths5$ToNode <- TwoKMPaths5$unlist.ToNode5.
TwoKMPaths5 <- TwoKMPaths5[retain]

TwoKMPaths6 <- read.csv("TwoKMPaths6.csv")
TwoKMPaths6$FromNode <- TwoKMPaths6$unlist.FromNode6.
TwoKMPaths6$ToNode <- TwoKMPaths6$unlist.ToNode6.
TwoKMPaths6 <- TwoKMPaths6[retain]

TwoKMPaths7 <- read.csv("TwoKMPaths7.csv")
TwoKMPaths7$FromNode <- TwoKMPaths7$unlist.FromNode7.
TwoKMPaths7$ToNode <- TwoKMPaths7$unlist.ToNode7.
TwoKMPaths7 <- TwoKMPaths7[retain]

TwoKMPaths8 <- read.csv("TwoKMPaths8.csv")
TwoKMPaths8$FromNode <- TwoKMPaths8$unlist.FromNode8.
TwoKMPaths8$ToNode <- TwoKMPaths8$unlist.ToNode8.
TwoKMPaths8 <- TwoKMPaths8[retain]

TwoKMPaths9 <- read.csv("TwoKMPaths9.csv")
TwoKMPaths9$FromNode <- TwoKMPaths9$unlist.FromNode9.
TwoKMPaths9$ToNode <- TwoKMPaths9$unlist.ToNode9.
TwoKMPaths9 <- TwoKMPaths9[retain]

TwoKMPaths10 <- read.csv("TwoKMPaths10.csv")
TwoKMPaths10$FromNode <- TwoKMPaths10$unlist.FromNode10.
TwoKMPaths10$ToNode <- TwoKMPaths10$unlist.ToNode10.
TwoKMPaths10 <- TwoKMPaths10[retain]

TwoKMPaths11 <- read.csv("TwoKMPaths11.csv")
TwoKMPaths11$FromNode <- TwoKMPaths11$unlist.FromNode11.
TwoKMPaths11$ToNode <- TwoKMPaths11$unlist.ToNode11.
TwoKMPaths11 <- TwoKMPaths11[retain]

TwoKMPaths12 <- read.csv("TwoKMPaths12.csv")
TwoKMPaths12$FromNode <- TwoKMPaths12$unlist.FromNode12.
TwoKMPaths12$ToNode <- TwoKMPaths12$unlist.ToNode12.
TwoKMPaths12 <- TwoKMPaths12[retain]

#combine 2.0 km connections into 1 data frame
TwoKMPathsCombined <- rbind(TwoKMPaths1, TwoKMPaths2, TwoKMPaths3, TwoKMPaths4, TwoKMPaths5, TwoKMPaths6, TwoKMPaths7, TwoKMPaths8, TwoKMPaths9, TwoKMPaths10, TwoKMPaths11, TwoKMPaths12)
TwoKMPathsCombined <- as.matrix(TwoKMPathsCombined[-97624,])

#create network with nodes and associated edges
TwoKMNetwork <- graph(n = 11711, edges = TwoKMPathsCombined, directed = FALSE)

#calculate node and edge betweeness for graph (number of shortest paths going through node or edge)
TwoKMNodeBetweenness <- betweenness(TwoKMNetwork, v = V(TwoKMNetwork), directed = FALSE, weights = NULL, normalized = FALSE)
TwoKMNodeBetweenness
MeanNodeBetweennessTwoKM <- mean(TwoKMNodeBetweenness)
MeanNodeBetweennessTwoKM

TwoKMEdgeBetweenness <- edge.betweenness(TwoKMNetwork, e = E(TwoKMNetwork), directed = FALSE, weights = NULL)
TwoKMEdgeBetweenness
MeanEdgeBetweennessTwoKM <- mean(TwoKMEdgeBetweenness)
MeanEdgeBetweennessTwoKM

#calculate degree (number of adjacent edges for each node)
DegreeTwoKMNetwork <- degree(TwoKMNetwork, v = V(TwoKMNetwork), loops = TRUE)
DegreeTwoKMNetwork
MeanDegreeTwoKMNetwork <- mean(DegreeTwoKMNetwork)
MeanDegreeTwoKMNetwork

#find number of clusters (groups of connected graph components)
TwoKMNetworkNumberClusters <- no.clusters(TwoKMNetwork)
TwoKMNetworkNumberClusters

#find mean number of vertices per cluster
TwoKMNetworkClusters <- clusters(TwoKMNetwork)
summary(TwoKMNetworkClusters$csize)
TwoKMNetworkMeanClusterSize <- mean(TwoKMNetworkClusters$csize)
TwoKMNetworkMeanClusterSize

#find subcomponent (all other vertices reachable from specified vertice)
TwoKMNetworkSC <- list(NA)
NumberReachedTwoKM <- list(NA)
for(i in 1:nrow(HistWets@data)){
	TwoKMNetworkSC[[i]] <- subcomponent(TwoKMNetwork, v = i)
	NumberReachedTwoKM[[i]] <- length(TwoKMNetworkSC[[i]]) - 1
}
NumberReachedTwoKM <- unlist(NumberReachedTwoKM)
NumberReachedTwoKMMean <- mean(NumberReachedTwoKM)
NumberReachedTwoKMMean

#edge betweeness community (creates hierarchical graph by removing edges most traveled when reaching other vertices via algorithm)
TwoKMNetworkEBC <- edge.betweenness.community(TwoKMNetwork, edge.betweenness = TRUE, merges = TRUE, bridges = TRUE)

#calculate eigenvector centrality scores of network positions (high scores = vertices connected to other highly connected which are connected to other highly connected etc...)
TwoKMNetworkEVCENT <- evcent(TwoKMNetwork, directed = FALSE, scale = FALSE)
TwoKMNetworkEVCENT

#calculate graph density (ratio of number of edges to number of possible edges)
TwoKMNetworkGraphDensity <- graph.density(TwoKMNetwork, loops = TRUE)
TwoKMNetworkGraphDensity

#identify neighbors of each vertice
TwoKMNetworkNeighbors <- list(NA)
for (i in 1:nrow(HistWets@data)){
	TwoKMNetworkNeighbors[[i]] <- neighbors(TwoKMNetwork, v = i)
}
TwoKMNetworkNeighbors

#calculate neighborhood size (number of interconnected vertices in each neighborhood)
TwoKMNetworkNeighborSize <- neighborhood.size(TwoKMNetwork, order = 1, nodes = V(TwoKMNetwork))
TwoKMNetworkNeighborSize

#calculate graph cohesion (vertex connectivity of graph)
TwoKMNetworkGraphCohesion <- graph.cohesion(TwoKMNetwork)
TwoKMNetworkGraphCohesion

#calculate average shortest path length between connected vertices
TwoKMNetworkAPL <- average.path.length(TwoKMNetwork, directed = FALSE, unconnected = TRUE)
TwoKMNetworkAPL

#generate histogram of shortest path lengths
TwoKMNetworkAPLHist <- path.length.hist(TwoKMNetwork, directed = FALSE)
TwoKMNetworkAPLHist

#experiment with deleting vertices/edges
NodeRemove <- list(NA)
MeanNodeDegreeRemoval <- list(NA)
MeanNodeBetweennessRemoval <- list(NA)
MeanEdgeBetweennessRemoval <- list(NA)
GraphDensityRemoval <- list(NA)
MeanShortPathLengthRemoval <- list(NA)
for(i in 1:nrow(HistWets@data)){
	NodeRemove[[i]] <- TwoKMNetwork
	NodeRemove[[i]][i] <- FALSE
	MeanNodeDegreeRemoval[[i]] <- mean(degree(NodeRemove[[i]], v = V(NodeRemove[[i]]), loops = TRUE))
	MeanNodeBetweennessRemoval[[i]] <- mean(betweenness(NodeRemove[[i]], v = V(NodeRemove[[i]]), directed = FALSE, weights = NULL, normalized = FALSE))
	MeanEdgeBetweennessRemoval[[i]] <- mean(edge.betweenness(NodeRemove[[i]], e = E(NodeRemove[[i]]), directed = FALSE, weights = NULL))
	GraphDensityRemoval[[i]] <- graph.density(NodeRemove[[i]], loops = TRUE)
	MeanShortPathLengthRemoval[[i]] <- average.path.length(NodeRemove[[i]], directed = FALSE, unconnected = TRUE)
}

#unlist mean degrees after removing each node
MeanNodeDegreeRemoval <- unlist(MeanNodeDegreeRemoval)
MeanNodeDegreeRemoval <- data.frame(MeanNodeDegreeRemoval)
MeanNodeDegreeRemoval$Degree <- MeanNodeDegreeRemoval[,1]
MeanNodeDegreeRemoval$NodeID <- HistWets@data$NodeID
MeanNodeDegreeRemoval$FP_ID <- HistWets@data$FP_ID
MeanNodeDegreeRemoval <- MeanNodeDegreeRemoval[,-1]
head(MeanNodeDegreeRemoval)

#unlist mean node betweenness after removing and replacing each node sequentially
MeanNodeBetweennessRemoval <- unlist(MeanNodeBetweennessRemoval)
MeanNodeBetweennessRemoval <- data.frame(MeanNodeBetweennessRemoval)
MeanNodeBetweennessRemoval$NodeBetweenness <- MeanNodeBetweennessRemoval[,1]
MeanNodeBetweennessRemoval$NodeID <- HistWets@data$NodeID
MeanNodeBetweennessRemoval$FP_ID <- HistWets@data$FP_ID
MeanNodeBetweennessRemoval <- MeanNodeBetweennessRemoval[,-1]
head(MeanNodeBetweennessRemoval)

#unlist mean edge betweenness after removing and replacing each node sequentially
MeanEdgeBetweennessRemoval <- unlist(MeanEdgeBetweennessRemoval)
MeanEdgeBetweennessRemoval <- data.frame(MeanEdgeBetweennessRemoval)
MeanEdgeBetweennessRemoval$EdgeBetweenness <- MeanEdgeBetweennessRemoval[,1]
MeanEdgeBetweennessRemoval$NodeID <- HistWets@data$NodeID
MeanEdgeBetweennessRemoval$FP_ID <- HistWets@data$FP_ID
MeanEdgeBetweennessRemoval <- MeanEdgeBetweennessRemoval[,-1]
head(MeanEdgeBetweennessRemoval)

#unlist graph density after removing and replacing each node sequentially
GraphDensityRemoval <- unlist(GraphDensityRemoval)
GraphDensityRemoval <- data.frame(GraphDensityRemoval)
GraphDensityRemoval$GraphDensity <- GraphDensityRemoval[,1]
GraphDensityRemoval$NodeID <- HistWets@data$NodeID
GraphDensityRemoval$FP_ID <- HistWets@data$FP_ID
GraphDensityRemoval <- GraphDensityRemoval[,-1]
head(GraphDensityRemoval)

#unlist mean shortest path length after removing and replacing each node sequentially
MeanShortPathLengthRemoval <- unlist(MeanShortPathLengthRemoval)
MeanShortPathLengthRemoval <- data.frame(MeanShortPathLengthRemoval)
MeanShortPathLengthRemoval$MeanPathLength <- MeanShortPathLengthRemoval[,1]
MeanShortPathLengthRemoval$NodeID <- HistWets@data$NodeID
MeanShortPathLengthRemoval$FP_ID <- HistWets@data$FP_ID
MeanShortPathLengthRemoval <- MeanShortPathLengthRemoval[,-1]
head(MeanShortPathLengthRemoval)

#add new outputs to attribute table
HistWets@data$Degree <- DegreeTwoKMNetwork
HistWets@data$NodeBetween <- TwoKMNodeBetweenness
HistWets@data$RemDeg <- MeanNodeDegreeRemoval$Degree
HistWets@data$RemNodeBetween <- MeanNodeBetweennessRemoval$NodeBetweenness
HistWets@data$RemEdgeBetween <- MeanEdgeBetweennessRemoval$EdgeBetweenness
HistWets@data$RemGraphDenity <- GraphDensityRemoval$GraphDensity
HistWets@data$RemShortPath <- MeanShortPathLengthRemoval$MeanPathLength

#write updated spatial polygons data frame as an ESRI shapefile
writeOGR(HistWets, "HistWetsTwoKMNetwork", "HistWetsTwoKMNetwork", driver = 'ESRI Shapefile', verbose = TRUE)



